module ALU(D3, D2, D1, D0, A3, A2, A1, A0, Zero, S3, S2, S1, S0, OP0, OP1);
  input		D3;
  input		D2;
  input		D1;
  input		D0;
  input		A3;
  input		A2;
  input		A1;
  input		A0;
  output	Zero;
  output	S3;
  output	S2;
  output	S1;
  output	S0;
  input		OP0;
  input		OP1;

  reg[3:0]	dval;
  reg[3:0]	aval;
  reg[3:0]	sval;
  reg[1:0]	opcode;

  assign dval = {D3, D2, D1, D0};
  assign aval = {A3, A2, A1, A0};
  assign opcode = {OP1, OP0};

  always @(dval or aval or opcode) begin
    case (opcode)
    2'b00:
      sval = dval + aval;
    2'b01:
      sval = dval - aval;     
    2'b10:
      sval = dval;
    2'b11:
      sval = aval;
    endcase
  end

  assign S3 = sval[3];
  assign S2 = sval[2];
  assign S1 = sval[1];
  assign S0 = sval[0];
  assign Zero = (sval == 0);

endmodule
